HDU 5573 【贪心】

2 篇文章 0 订阅

Binary Tree

Problem Description

The Old Frog King lives on the root of an infinite tree. According to the law, each node should connect to exactly two nodes on the next level, forming a full binary tree.

Since the king is professional in math, he sets a number to each node. Specifically, the root of the tree, where the King lives, is 1. Say froot=1.

And for each node u, labels as fu, the left child is fu×2 and right child is fu×2+1. The king looks at his tree kingdom, and feels satisfied.

Time flies, and the frog king gets sick. According to the old dark magic, there is a way for the king to live for another N years, only if he could collect exactly N soul gems.

Initially the king has zero soul gems, and he is now at the root. He will walk down, choosing left or right child to continue. Each time at node x, the number at the node is fx (remember froot=1), he can choose to increase his number of soul gem by fx, or decrease it by fx.

He will walk from the root, visit exactly K nodes (including the root), and do the increasement or decreasement as told. If at last the number is N, then he will succeed.

Noting as the soul gem is some kind of magic, the number of soul gems the king has could be negative.

Given N, K, help the King find a way to collect exactly N soul gems by visiting exactly K nodes.

Input

First line contains an integer T, which indicates the number of test cases.

Every test case contains two integers N and K, which indicates soul gems the frog king want to collect and number of nodes he can visit.

⋅ 1≤T≤100.

⋅ 1≤N≤109.

⋅ N≤2K≤260.

Output

For every test case, you should output “Case #x:” first, where x indicates the case number and counts from 1.

Then K lines follows, each line is formated as ‘a b’, where a is node label of the node the frog visited, and b is either ‘+’ or ‘-’ which means he increases / decreases his number by a.

It’s guaranteed that there are at least one solution and if there are more than one solutions, you can output any of them.

Sample Input

2
5 3
10 4

Sample Output

Case #1:
1 +
3 -
7 +
Case #2:
1 +
3 +
6 -
12 +

Solution

有一棵满二叉树,每个节点的编号如下图所示,最多只有60层,求准确地跑k层之后得到n的全过程,必须对每一层的值可选择加或者减,初始为0.
满二叉树
组队训练的时候学长和队友忙活A题的大模拟,我把每一层每个节点的可能性列出来,写了4层之后发现,除了最后一层之外,前面的所有层数都可以走最左边,最后一层的作用是决定奇偶,如4层的时候,可以选择1-2-4-8或者1-2-4-9,这两种走法可以得到所有合法的n值。但是找到规律之后没有及时想到贪心,后来学长提醒我可以使用从后往前贪心。计算的时候需要注意最后一层特判、数据范围和pow函数返回值是double类型。

Code

#include<iostream>
#include<cmath>
#include<cstring>
#include<cstdio>
using namespace std;
typedef long long ll;

bool vis[100];

int main() {
	int t,cas = 0;
	cin >> t;
	while(t--) {
		memset(vis,0,sizeof(vis));
		ll n,k;
		cin >> n >> k;
		int zf;
		if(n & 1) {
			zf = 1;
		} else {
			zf = 0;
		}
		ll total = pow(2,k) - zf;
		ll last = pow(2,k-1)+1-zf;
		if(total - n >= 2 * last) {
			vis[k] = true;
			total -= 2 * last;
		}
		ll kk = k;
		while(kk--) {
			if(!kk) {
				break;
			}
			if(total - n >= pow(2,kk)) {
				vis[kk] = true;
				total -= pow(2,kk);
			}
		}
		printf("Case #%d:\n",++cas);
		for(int i=1; i<k; i++) {
			ll temp = pow(2,i-1);
			if(vis[i]) {
				cout << temp << " -" << endl;
			} else {
				cout << temp << " +" << endl;
			}
		}
		if(vis[k]) {
			cout << last << " -" << endl;
		} 
		else {
			cout << last << " + " << endl;
		}
	}
}

Source

HDU 5573 Binary Tree

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值